* RESEQ.PRG  DBASE PROGRAM TO RESEQUENCE COBOL SOURCE CODE
*            TO UPLOAD TO CANDE ON UNISYS A3 SMALL MAINFRAME.
*  SAFETY
SET CURSOR OFF

SET SAFETY OFF
DO WHILE .T.

CLOSE DATA
SET COLOR TO W/B
CLEAR
STORE SPACE(8) TO SOURCE
STORE SPACE(8) TO TARGET
STORE 14 TO BUFFREAD
@ 3,10 SAY "Cobol Source Line Re-Numbering Utility"
@ 4,10 SAY "     Written by Kirk E. Knecht"
* TURN CURSOR ON
SET CURSOR ON
*--Testing shows that 14 is best
@ 6,10 SAY "Enter Number of Records to Buffer: "
@ 6,COL() GET BUFFREAD PICT "999"
READ
IF BUFFREAD = 0
   EXIT
ENDIF
@ 6,10 CLEAR TO 6,78
@ 6,10 SAY "Source File's Name: "
@ 6,30 GET SOURCE PICT "!!!!!!!!"
READ
SOURCE = TRIM(SOURCE)
DO WHILE .T.
   @ 8,10 CLEAR TO 8,78
   IF LEN(TRIM(SOURCE)) = 0
      CLEAR
      RETURN
   ENDIF
   IF .NOT. FILE("&SOURCE.")
      ?? CHR(7)
      @ 8,10 SAY SOURCE+" Not Found.  Try it again."
      STORE SPACE(8) TO SOURCE
      @ 6,30 GET SOURCE PICT "!!!!!!!!"
      READ
      SOURCE = TRIM(SOURCE)
      CLEAR GETS
      LOOP
   ENDIF
   EXIT
ENDDO
* TURN CURSOR OFF
SET CURSOR OFF
@ 6,10 CLEAR TO 6,78
* MAKE BACKUP COPY OF SOURCE
SET COLOR TO W+/B
@ 6,10 SAY "Making backup copy of source file "
@ 6,COL() SAY SOURCE+"."
COPY FILE &SOURCE. TO &SOURCE..RS
SET COLOR TO W/B
@ 6,10 SAY "Making backup copy of source file "
@ 6,COL() SAY SOURCE+"."
* OPEN 72 COLUMN 1 FIELD WORKFILE
USE IN72
ZAP
* BRING IN COBOL PROGRAM TO BE RESEQUENCED
SET COLOR TO W+/B
@ 7,10 SAY "Appending source into work DBF."
APPEND FROM &SOURCE.. SDF
SET COLOR TO W/B
@ 7,10 SAY "Appending source into work DBF."
SET COLOR TO W+/B
@ 8,10 SAY SOURCE+" contains "+LTRIM(TRANS(RECCOUNT(),"99,999"))+" lines."
* SAFETY
CLOSE DATA

* MAKE COUNTER TO INCREMENT
STORE 100 TO LINENO
* RE-OPEN 72 COLUMN 1 FIELD WORKFILE
USE IN72
* LOOP UNTIL ALL LINES OF IN72 ARE READ AND PROCESSED
SET COLOR TO W/B
@ 8,10 SAY SOURCE+" contains "+LTRIM(TRANS(RECCOUNT(),"99,999"))+" lines."
SET COLOR TO W+/B
@ 9,10 SAY "Now processing the file."
SET COLOR TO W/B

* CREATE OUTFILE
HANDLE = FCREATE("&SOURCE.", 0)    && READ/WRITE MODE
IF FERROR() <> 0
   ? "Can't create file, DOS error ", FERROR()
   INKEY(0)
   RETURN
ENDIF

DO BARGRAPH
STORE 2 TO PERCENT
STORE 0 TO LINES
STORE RECCOUNT() TO NORECS
STORE INT(ROUND(NORECS * (PERCENT / 100),0)) TO CHECKPT
STORE 8 TO COL
STORE "" TO GRAPH

STORE "" TO BUFFER
STORE 0 TO WRTCNT

STORE SECONDS() TO START
DO WHILE .NOT. EOF()
   IF RECNO() >= CHECKPT
      @ 20, COL SAY GRAPH
      STORE PERCENT +2 TO PERCENT
      STORE INT(ROUND(NORECS * (PERCENT / 100),0)) TO CHECKPT
      STORE COL +1 TO COL
   ENDIF
   * PAD LINENO TO SIX CHARACTERS
   STORE STR(LINENO,6) TO FIRSTSIX
   FIRSTSIX = STUFF( FIRSTSIX,1,(6 - LEN(LTRIM(FIRSTSIX))), ;
      REPLICATE("0",6-LEN(LTRIM(FIRSTSIX))) )
   * WRITE OUT NEWLY SEQUENCED LINE AS ASCII TEXT FILE
   STORE BUFFER + TRIM(STUFF(OLDLINE,1,6,FIRSTSIX))+CHR(13)+CHR(10) TO BUFFER
   STORE WRTCNT +1 TO WRTCNT
   IF WRTCNT = BUFFREAD
      IF FWRITE(HANDLE, BUFFER) < LEN(BUFFER)
         ? "Error writing record, DOS error ", FERROR()
         FCLOSE(HANDLE)
         INKEY(0)
         RETURN
      ELSE
         STORE 0 TO WRTCNT
         STORE "" TO BUFFER
      ENDIF
   ENDIF
   * INCREMENT LINE COUNTER
   STORE LINENO +100 TO LINENO
   SKIP 1
ENDDO
*--Write last of buffer
IF WRTCNT > 0
   IF FWRITE(HANDLE, BUFFER) < LEN(BUFFER)
      ? "Error writing record, DOS error ", FERROR()
      FCLOSE(HANDLE)
      INKEY(0)
      RETURN
   ELSE
      STORE 0 TO WRTCNT
   ENDIF
ENDIF
@ 20, COL SAY GRAPH+GRAPH+GRAPH
* WRAPUP

CLOSE DATA
FCLOSE(HANDLE)

STORE SECONDS() - START TO ELASPED
* ALL IS OK AT THIS POINT, SO GET RID OF BACKUP
@ 9,10 SAY "Now processing the file."
SET COLOR TO W+/B
@ 10,10 SAY "Erasing the .RS backup file."
ERASE &SOURCE..RS
SET COLOR TO W/B
@ 10,10 SAY "Erasing the .RS backup file."
SET COLOR TO W+/B
@ 11,10 SAY "Zapping work DBF."
SET COLOR TO W/B
USE IN72
ZAP
CLOSE DATA
@ 11,10 SAY "Zapping work DBF."
SET COLOR TO W*+/B
@ 12,10 SAY "Finished!  Press any key."
SET COLOR TO W/B
@ 14, 10 SAY "Elasped time (in seconds) was "
@ 14, COL() SAY LTRIM(STR(ELASPED))

INKEY(0)
* TURN CURSOR ON
STORE 0 TO COL,ROW
DO WHILE COL < 36
   @ ROW, COL CLEAR TO ROW, 79-COL
   @ 24-ROW, COL CLEAR TO 24-ROW, 79-COL
   @ ROW, COL CLEAR TO 24-ROW, COL+3
   @ ROW, 79-COL-3 CLEAR TO 24-ROW, 79-COL
   ROW = ROW +1
   COL = COL +3
   STORE INKEY(.05) TO DELAY
ENDDO
SET CURSOR ON

ENDDO (WHILE .T.)
CLEAR
RETURN
* EOF RESEQ.PRG
